/* tslint:disable */
/* eslint-disable */
/**
 * e-commerce-service
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.1.74
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../base';
// @ts-ignore
import { CatalogDetailResponseDto } from '../models';
// @ts-ignore
import { CatalogListResponseDto } from '../models';
/**
 * CatalogsApi - axios parameter creator
 * @export
 */
export const CatalogsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string} productId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        catalogControllerGetCatalogDetail: async (productId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'productId' is not null or undefined
            assertParamExists('catalogControllerGetCatalogDetail', 'productId', productId)
            const localVarPath = `/catalogs/{productId}`
                .replace(`{${"productId"}}`, encodeURIComponent(String(productId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {number} pageIndex 
         * @param {number} pageSize 
         * @param {string} currentCountry 
         * @param {string} [parentCategoryId] 
         * @param {string} [categoryId] 
         * @param {string} [keyword] 
         * @param {Array<string>} [productIds] 
         * @param {Array<string>} [categoryIds] 
         * @param {Array<CatalogControllerGetCatalogsProductTypesEnum>} [productTypes] 
         * @param {CatalogControllerGetCatalogsSortByEnum} [sortBy] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        catalogControllerGetCatalogs: async (pageIndex: number, pageSize: number, currentCountry: string, parentCategoryId?: string, categoryId?: string, keyword?: string, productIds?: Array<string>, categoryIds?: Array<string>, productTypes?: Array<CatalogControllerGetCatalogsProductTypesEnum>, sortBy?: CatalogControllerGetCatalogsSortByEnum, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'pageIndex' is not null or undefined
            assertParamExists('catalogControllerGetCatalogs', 'pageIndex', pageIndex)
            // verify required parameter 'pageSize' is not null or undefined
            assertParamExists('catalogControllerGetCatalogs', 'pageSize', pageSize)
            // verify required parameter 'currentCountry' is not null or undefined
            assertParamExists('catalogControllerGetCatalogs', 'currentCountry', currentCountry)
            const localVarPath = `/catalogs`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)

            if (parentCategoryId !== undefined) {
                localVarQueryParameter['parentCategoryId'] = parentCategoryId;
            }

            if (categoryId !== undefined) {
                localVarQueryParameter['categoryId'] = categoryId;
            }

            if (keyword !== undefined) {
                localVarQueryParameter['keyword'] = keyword;
            }

            if (productIds) {
                localVarQueryParameter['productIds'] = productIds;
            }

            if (categoryIds) {
                localVarQueryParameter['categoryIds'] = categoryIds;
            }

            if (productTypes) {
                localVarQueryParameter['productTypes'] = productTypes;
            }

            if (sortBy !== undefined) {
                localVarQueryParameter['sortBy'] = sortBy;
            }

            if (pageIndex !== undefined) {
                localVarQueryParameter['pageIndex'] = pageIndex;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['pageSize'] = pageSize;
            }

            if (currentCountry != null) {
                localVarHeaderParameter['current-country'] = String(currentCountry);
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CatalogsApi - functional programming interface
 * @export
 */
export const CatalogsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = CatalogsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {string} productId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async catalogControllerGetCatalogDetail(productId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CatalogDetailResponseDto>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.catalogControllerGetCatalogDetail(productId, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['CatalogsApi.catalogControllerGetCatalogDetail']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
        /**
         * 
         * @param {number} pageIndex 
         * @param {number} pageSize 
         * @param {string} currentCountry 
         * @param {string} [parentCategoryId] 
         * @param {string} [categoryId] 
         * @param {string} [keyword] 
         * @param {Array<string>} [productIds] 
         * @param {Array<string>} [categoryIds] 
         * @param {Array<CatalogControllerGetCatalogsProductTypesEnum>} [productTypes] 
         * @param {CatalogControllerGetCatalogsSortByEnum} [sortBy] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async catalogControllerGetCatalogs(pageIndex: number, pageSize: number, currentCountry: string, parentCategoryId?: string, categoryId?: string, keyword?: string, productIds?: Array<string>, categoryIds?: Array<string>, productTypes?: Array<CatalogControllerGetCatalogsProductTypesEnum>, sortBy?: CatalogControllerGetCatalogsSortByEnum, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CatalogListResponseDto>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.catalogControllerGetCatalogs(pageIndex, pageSize, currentCountry, parentCategoryId, categoryId, keyword, productIds, categoryIds, productTypes, sortBy, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['CatalogsApi.catalogControllerGetCatalogs']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
    }
};

/**
 * CatalogsApi - factory interface
 * @export
 */
export const CatalogsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = CatalogsApiFp(configuration)
    return {
        /**
         * 
         * @param {string} productId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        catalogControllerGetCatalogDetail(productId: string, options?: any): AxiosPromise<CatalogDetailResponseDto> {
            return localVarFp.catalogControllerGetCatalogDetail(productId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {number} pageIndex 
         * @param {number} pageSize 
         * @param {string} currentCountry 
         * @param {string} [parentCategoryId] 
         * @param {string} [categoryId] 
         * @param {string} [keyword] 
         * @param {Array<string>} [productIds] 
         * @param {Array<string>} [categoryIds] 
         * @param {Array<CatalogControllerGetCatalogsProductTypesEnum>} [productTypes] 
         * @param {CatalogControllerGetCatalogsSortByEnum} [sortBy] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        catalogControllerGetCatalogs(pageIndex: number, pageSize: number, currentCountry: string, parentCategoryId?: string, categoryId?: string, keyword?: string, productIds?: Array<string>, categoryIds?: Array<string>, productTypes?: Array<CatalogControllerGetCatalogsProductTypesEnum>, sortBy?: CatalogControllerGetCatalogsSortByEnum, options?: any): AxiosPromise<CatalogListResponseDto> {
            return localVarFp.catalogControllerGetCatalogs(pageIndex, pageSize, currentCountry, parentCategoryId, categoryId, keyword, productIds, categoryIds, productTypes, sortBy, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * CatalogsApi - object-oriented interface
 * @export
 * @class CatalogsApi
 * @extends {BaseAPI}
 */
export class CatalogsApi extends BaseAPI {
    /**
     * 
     * @param {string} productId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CatalogsApi
     */
    public catalogControllerGetCatalogDetail(productId: string, options?: RawAxiosRequestConfig) {
        return CatalogsApiFp(this.configuration).catalogControllerGetCatalogDetail(productId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {number} pageIndex 
     * @param {number} pageSize 
     * @param {string} currentCountry 
     * @param {string} [parentCategoryId] 
     * @param {string} [categoryId] 
     * @param {string} [keyword] 
     * @param {Array<string>} [productIds] 
     * @param {Array<string>} [categoryIds] 
     * @param {Array<CatalogControllerGetCatalogsProductTypesEnum>} [productTypes] 
     * @param {CatalogControllerGetCatalogsSortByEnum} [sortBy] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CatalogsApi
     */
    public catalogControllerGetCatalogs(pageIndex: number, pageSize: number, currentCountry: string, parentCategoryId?: string, categoryId?: string, keyword?: string, productIds?: Array<string>, categoryIds?: Array<string>, productTypes?: Array<CatalogControllerGetCatalogsProductTypesEnum>, sortBy?: CatalogControllerGetCatalogsSortByEnum, options?: RawAxiosRequestConfig) {
        return CatalogsApiFp(this.configuration).catalogControllerGetCatalogs(pageIndex, pageSize, currentCountry, parentCategoryId, categoryId, keyword, productIds, categoryIds, productTypes, sortBy, options).then((request) => request(this.axios, this.basePath));
    }
}

/**
 * @export
 */
export const CatalogControllerGetCatalogsProductTypesEnum = {
    Main: 'main',
    Addons: 'addons',
    ECommerce: 'e_commerce',
    Program: 'program',
    EVoucher: 'e_voucher'
} as const;
export type CatalogControllerGetCatalogsProductTypesEnum = typeof CatalogControllerGetCatalogsProductTypesEnum[keyof typeof CatalogControllerGetCatalogsProductTypesEnum];
/**
 * @export
 */
export const CatalogControllerGetCatalogsSortByEnum = {
    Asc: 'name_asc',
    Desc: 'name_desc'
} as const;
export type CatalogControllerGetCatalogsSortByEnum = typeof CatalogControllerGetCatalogsSortByEnum[keyof typeof CatalogControllerGetCatalogsSortByEnum];
